local doors = {}

RegisterNetEvent('vrpdoorsystem:load')
AddEventHandler('vrpdoorsystem:load', function(list)
  doors = list
end)

RegisterNetEvent("vrpdoorsystem:animatie")
AddEventHandler("vrpdoorsystem:animatie", function()
	playAnim('mp_arresting','a_uncuff', 8.0, 1.0, -1, 49, 0, 0, 0, 0, true ,true)
end)

RegisterNetEvent('vrpdoorsystem:statusSend')
AddEventHandler('vrpdoorsystem:statusSend', function(i, status)
	if doors[i] ~= nil then
		doors[i].locked = status
	end
end)


function searchIdDoor()
  local pc = GetEntityCoords(PlayerPedId())
  for k,v in pairs(doors) do
    if #(pc - vector3(v.x,v.y,v.z)) <= 1.5 then
      return k
    end
  end
  return 0
end

RegisterCommand("setheading",function(_,args)
  if LocalPlayer.state.user_id < 10 then
    if not args[1] then return TriggerEvent("chatMessage", "^1Syntax: ^0/setheading [heading]") end
    local heading = args[1] + 0.0
    SetEntityHeading(PlayerPedId(), heading)
  end
end)

RegisterCommand("getdoorid",function(_,args)
  if LocalPlayer.state.user_id < 10 then
    local d_id = searchIdDoor()
    if d_id ~= 0 then
      TriggerEvent("chatMessage", "^1Nearest door id founded: ^0"..d_id)
    else
      TriggerEvent("chatMessage", "^1Door id not founded.")
    end
  end
end)

RegisterCommand("gotodoors",function(_, args)
  if LocalPlayer.state.user_id < 10 then
    if not args[1] then return TriggerEvent("^1Syntax: /gotodoors [door-id] (for devs)") end
    local id = parseInt(args[1])
    if doors[id] then
      SetEntityCoords(PlayerPedId(), doors[id].x, doors[id].y, doors[id].z)
    end
  end
end)

Citizen.CreateThread(function()
  while true do
    Citizen.Wait(1)
    if IsControlJustPressed(0,46) then
      local id = searchIdDoor()
      if id ~= 0 then
        TriggerServerEvent("vrpdoorsystem:open", id)
      end
    end
  end
end)

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(100)
    local inRange = false
		local rpc = GetEntityCoords(PlayerPedId())
		for k, v in pairs(doors) do
			if #(rpc - vector3(v.x, v.y, v.z)) <= 10 then
        inRange = true
				local door = GetClosestObjectOfType(v.x, v.y, v.z, 1.0, v.hash, false, false, false)
				if door ~= 0 then
					SetEntityCanBeDamaged(door, false)
					if v.locked == false then
						NetworkRequestControlOfEntity(door)
						FreezeEntityPosition(door, false)
					else
						local locked, heading = GetStateOfClosestDoorOfType(v.hash, v.x, v.y, v.z, locked, heading)
						if heading > -0.02 and heading < 0.02 then
							NetworkRequestControlOfEntity(door)
							FreezeEntityPosition(door, true)
						end
					end
				end
			end
		end
      if not inRange then
          Citizen.Wait(500)
      end
	end
end)
